[resolved]Debian Etch safe_asterisk v /etc/init.d/asterisk

problem was permissions on /usr/share/asterisk. It was set to root, changed to asterisk:asterisk


I have a strange problem. I am running Debain Etch with kernel 2.6.18.
I installed Asterisk using apt-get install asterisk.
I installed Freepbx and all seems to be working. I add a couple of extensions but when I call between them it goes straight to voice mail.
I found if I shut down asterisk /etc/init.d/asterisk stop then run /usr/sbin/safe_asterisk the extensions can then call each other.

doing a ps ax | grep asterisk shows this when running from /etc/init.d/asterisk script that came with the install:
2194 ? Ssl 0:00 /usr/sbin/asterisk -p -U asterisk

when i run safe_asterisk instead ps shows this:
2286 pts/0 S 0:00 /bin/sh /usr/sbin/safe_asterisk
2290 pts/0 Sl 0:00 /usr/sbin/asterisk -vvvg -c

any clues why extensions work correctly when running safe_asterisk?

here is what is in /etc/init.d/asterisk

#! /bin/sh

asterisk start the asterisk PBX

© Mark Purcell msp@debian.org

May be distributed under the terms of this General Public License

Based on:

skeleton example file to build /etc/init.d/ scripts.

This file should be used to construct scripts for /etc/init.d.

Written by Miquel van Smoorenburg miquels@cistron.nl.

Modified for Debian GNU/Linux

by Ian Murdock imurdock@gnu.ai.mit.edu.

Version: @(#)skeleton 1.9 26-Feb-2001 miquels@cistron.nl

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
NAME=asterisk
USER=$NAME
GROUP=$USER
DAEMON=/usr/sbin/$NAME
DESC=“Asterisk PBX"
PIDFILE=”/var/run/asterisk/asterisk.pid"
ASTSAFE_PIDFILE="/var/run/asterisk/asterisk_safe.pid"

by default: use real-time priority

PARAMS=""
AST_REALTIME="yes"
RUNASTERISK="no"
if [ -r /etc/default/$NAME ]; then . /etc/default/$NAME; fi

if [ “$RUNASTERISK” != “yes” ];then
echo "Asterisk not yet configured. Edit /etc/default/asterisk first."
exit 0
fi

if [ “$AST_REALTIME” != “no” ]
then
PARAMS="$PARAMS -p"
fi

if [ “x$USER” = “x” ]
then
echo "Error: empty USER name"
exit 1
fi
if [ id -u "$USER" = 0 ]
then
echo “Starting as root not supported.“
exit 1
fi
PARAMS=”$PARAMS -U $USER”

if [ “x$AST_DEBUG_PARAMS” = x ]
then
AST_DEBUG_PARAMS=-cvvvvvddddd
fi
if [ “$RUNASTSAFE” = “yes” ];then
# The value of WRAPPER_DAEMON in can be set in /etc/default/asterisk
WRAPPER_DAEMON=${WRAPPER_DAEMON:-/usr/sbin/safe_asterisk}
REALDAEMON="$WRAPPER_DAEMON"
else
REALDAEMON="$DAEMON"
fi

test -x $DAEMON || exit 0

set -e

status() {
plist=ps auxw | grep "$DAEMON" | grep -v grep | awk '{print $2}' | tr '\012' ' '
if [ “$plist” = “” ]; then
echo "$DESC is stopped"
return 1
else
echo "$DESC is running: $plist"
return 0
fi
}

case “$1” in
debug)
# we add too many special parameters that I don’t want to skip
# accidentally. I’m afraid that skipping -U once may cause
# confusing results. I also want to maintain the user’s choice
# of -p
echo "Debugging $DESC: "
$DAEMON $PARAMS $AST_DEBUG_PARAMS
exit 0
;;
start)
if status > /dev/null; then
echo "$DESC is already running. Use restart."
exit 0
fi
echo -n "Starting $DESC: "
if [ “$RUNASTSAFE” != “yes” ];then
# TODO: what if we cought the wrapper just as its asterisk
# was killed? status should check for the wrapper if we’re in
# "safe mode"
if status > /dev/null; then
echo "$DESC is already running. Use restart."
exit 0
fi
start-stop-daemon --start --group $GROUP --pidfile “$PIDFILE”
–exec $REALDAEMON – $PARAMS
else
start-stop-daemon --start --group $GROUP --make-pidfile
–pidfile “$ASTSAFE_PIDFILE”
–exec $REALDAEMON – $PARAMS
fi

    echo "$NAME."
    ;;

stop)
echo -n "Stopping $DESC: "
if [ “$RUNASTSAFE” = “yes” ];then
# hopefully this will work. Untested
$REALDAEMON -rx ‘stop now’ > /dev/null || true
else
# Try gracefully.
# this may hang in some cases. Specifically, when the asterisk
# processes is stopped. No bother to worry about cleanup:
# it will either fail or die when asterisk dies.
( $DAEMON -rx ‘stop now’ > /dev/null 2>&1 & ) &
fi
echo -n “$NAME”
## giving a small grace time to shut down cleanly.
#sleep 2 # you can add timeouts in the comma
if [ “$RUNASTSAFE” = “yes” ];then
start-stop-daemon --quiet --pidfile $ASTSAFE_PIDFILE --oknodo
–stop
fi
# just making sure it’s really, really dead.
# KILL is necessary just in case there’s an asterisk -r in the background
start-stop-daemon --stop --quiet --oknodo --retry=0/2/TERM/2/KILL/5 --exec $DAEMON
echo “.”
;;
reload)
echo “Reloading $DESC configuration files.”
$DAEMON -rx ‘reload’ || true
;;
logger-reload)
$DAEMON -rx ‘logger reload’ || true
;;
extensions-reload)
echo “Reloading $DESC configuration files.”
$DAEMON -rx ‘extensions reload’ || true
;;
restart|force-reload)
$0 stop
$0 start
;;
status)
status
exit $?
;;
zaptel-fix)
echo “Unloading and reloading loading Asterisk and Zaptel:”
$0 stop
/etc/init.d/zaptel unload
# load modules from /etc/modules. This will break if you count on
# discover/hotplug
/etc/init.d/module-init-tools
/etc/init.d/zaptel start
$0 start
;;
*)
N=/etc/init.d/$NAME
echo “Usage: $N {start|stop|restart|reload|status|debug|logger-reload|extensions-reload|force-reload}” >&2
exit 1
;;
esac

exit 0